// This file is part of the SV-Benchmarks collection of verification tasks:
// https://gitlab.com/sosy-lab/benchmarking/sv-benchmarks
//
// SPDX-FileCopyrightText: 2020 Aman Goel
// SPDX-FileCopyrightText: 2022 The SV-Benchmarks Community
//
// SPDX-License-Identifier: GPL-3.0-or-later

// This C program is converted from Btor2 by Btor2C version sha1:a0fa249
//   with arguments: { architecture=64, lazy_modulo=false, use_memmove=false, unroll_inner_loops=false, shortest_type=true, diff_type=true, decimal_constant=true, zero_init=false, sra_extend_sign=true }
// Comments from the original Btor2 file:
// ; source: https://github.com/aman-goel/avr/tree/92362931700b66684418a991d018c9fbdbebc06f/tests
// ; BTOR description generated by Yosys 0.9+431 (git sha1 4a3b5437, clang 4.0.1-6 -fPIC -Os) for module main.
extern unsigned char __VERIFIER_nondet_uchar();
extern unsigned short __VERIFIER_nondet_ushort();
extern unsigned int __VERIFIER_nondet_uint();
extern unsigned long __VERIFIER_nondet_ulong();
extern void abort(void);
extern void __assert_fail(const char *, const char *, unsigned int, const char *);
void reach_error() { __assert_fail("0", "diagonal_v.c", 0, "reach_error"); }
void __VERIFIER_assert(int cond) { if (!(cond)) { ERROR: { reach_error(); abort(); } } }
void assume_abort_if_not(int cond) { if (!cond) { abort(); } }
int main() {
  // Defining sorts ...
  typedef unsigned char SORT_1;  // BV with 1 bits
  const SORT_1 mask_SORT_1 = (SORT_1)-1 >> (sizeof(SORT_1) * 8 - 1);
  const SORT_1 msb_SORT_1 = (SORT_1)1 << (1 - 1);
  typedef unsigned char SORT_4;  // BV with 4 bits
  const SORT_4 mask_SORT_4 = (SORT_4)-1 >> (sizeof(SORT_4) * 8 - 4);
  const SORT_4 msb_SORT_4 = (SORT_4)1 << (4 - 1);
  typedef unsigned int SORT_28;  // BV with 32 bits
  const SORT_28 mask_SORT_28 = (SORT_28)-1 >> (sizeof(SORT_28) * 8 - 32);
  const SORT_28 msb_SORT_28 = (SORT_28)1 << (32 - 1);
  // Initializing constants ...
  const SORT_4 var_5 = 1;
  const SORT_4 var_8 = 0;
  const SORT_1 var_15 = 1;
  const SORT_4 var_22 = 15;
  const SORT_28 var_30 = 1;
  // Collecting input declarations ...
  SORT_1 input_2;
  SORT_1 input_3;
  // Collecting state declarations ...
  SORT_4 state_6 = __VERIFIER_nondet_uchar() & mask_SORT_4;
  SORT_4 state_9 = __VERIFIER_nondet_uchar() & mask_SORT_4;
  // Initializing states ...
  SORT_4 init_7_arg_1 = var_5;
  state_6 = init_7_arg_1;
  SORT_4 init_10_arg_1 = var_8;
  state_9 = init_10_arg_1;
  for (;;) {
    // Getting external input values ...
    input_2 = __VERIFIER_nondet_uchar();
    input_2 = input_2 & mask_SORT_1;
    input_3 = __VERIFIER_nondet_uchar();
    input_3 = input_3 & mask_SORT_1;
    // Assuming invariants ...
    // Asserting properties ...
    SORT_4 var_11_arg_0 = state_6;
    SORT_4 var_11_arg_1 = state_9;
    SORT_1 var_11 = var_11_arg_0 < var_11_arg_1;
    SORT_1 var_12_arg_0 = var_11;
    SORT_1 var_12 = ~var_12_arg_0;
    var_12 = var_12 & mask_SORT_1;
    SORT_1 var_16_arg_0 = var_12;
    SORT_1 var_16 = ~var_16_arg_0;
    var_16 = var_16 & mask_SORT_1;
    SORT_1 var_17_arg_0 = var_15;
    SORT_1 var_17_arg_1 = var_16;
    SORT_1 var_17 = var_17_arg_0 & var_17_arg_1;
    var_17 = var_17 & mask_SORT_1;
    SORT_1 bad_18_arg_0 = var_17;
    __VERIFIER_assert(!(bad_18_arg_0));
    // Computing next states ...
    SORT_1 var_37_arg_0 = input_3;
    SORT_1 var_37 = ~var_37_arg_0;
    var_37 = var_37 & mask_SORT_1;
    SORT_4 var_38_arg_0 = state_6;
    SORT_4 var_38_arg_1 = state_9;
    SORT_1 var_38 = var_38_arg_0 > var_38_arg_1;
    SORT_1 var_39_arg_0 = var_37;
    SORT_1 var_39_arg_1 = var_38;
    SORT_1 var_39 = var_39_arg_0 & var_39_arg_1;
    var_39 = var_39 & mask_SORT_1;
    SORT_4 var_29_arg_0 = var_22;
    SORT_28 var_29 = var_29_arg_0;
    SORT_28 var_31_arg_0 = var_29;
    SORT_28 var_31_arg_1 = var_30;
    SORT_28 var_31 = var_31_arg_0 >> var_31_arg_1;
    SORT_28 var_32_arg_0 = var_31;
    SORT_4 var_32 = var_32_arg_0 >> 0;
    var_32 = var_32 & mask_SORT_4;
    SORT_4 var_33_arg_0 = state_6;
    SORT_28 var_33 = var_33_arg_0;
    SORT_28 var_34_arg_0 = var_33;
    SORT_28 var_34_arg_1 = var_30;
    SORT_28 var_34 = var_34_arg_0 >> var_34_arg_1;
    SORT_28 var_35_arg_0 = var_34;
    SORT_4 var_35 = var_35_arg_0 >> 0;
    var_35 = var_35 & mask_SORT_4;
    SORT_4 var_36_arg_0 = var_32;
    SORT_4 var_36_arg_1 = var_35;
    SORT_4 var_36 = var_36_arg_0 + var_36_arg_1;
    var_36 = var_36 & mask_SORT_4;
    SORT_4 var_26_arg_0 = state_6;
    SORT_4 var_26_arg_1 = state_9;
    SORT_1 var_26 = var_26_arg_0 < var_26_arg_1;
    SORT_4 var_21_arg_0 = state_9;
    SORT_4 var_21_arg_1 = state_6;
    SORT_1 var_21 = var_21_arg_0 == var_21_arg_1;
    SORT_4 var_23_arg_0 = state_6;
    SORT_4 var_23_arg_1 = var_22;
    SORT_1 var_23 = var_23_arg_0 != var_23_arg_1;
    SORT_1 var_24_arg_0 = var_21;
    SORT_1 var_24_arg_1 = var_23;
    SORT_1 var_24 = var_24_arg_0 | var_24_arg_1;
    var_24 = var_24 & mask_SORT_1;
    SORT_4 var_20_arg_0 = state_6;
    SORT_4 var_20_arg_1 = var_5;
    SORT_4 var_20 = var_20_arg_0 + var_20_arg_1;
    var_20 = var_20 & mask_SORT_4;
    SORT_1 var_25_arg_0 = var_24;
    SORT_4 var_25_arg_1 = var_20;
    SORT_4 var_25_arg_2 = state_9;
    SORT_4 var_25 = var_25_arg_0 ? var_25_arg_1 : var_25_arg_2;
    SORT_1 var_27_arg_0 = var_26;
    SORT_4 var_27_arg_1 = state_6;
    SORT_4 var_27_arg_2 = var_25;
    SORT_4 var_27 = var_27_arg_0 ? var_27_arg_1 : var_27_arg_2;
    SORT_1 var_40_arg_0 = var_39;
    SORT_4 var_40_arg_1 = var_36;
    SORT_4 var_40_arg_2 = var_27;
    SORT_4 var_40 = var_40_arg_0 ? var_40_arg_1 : var_40_arg_2;
    SORT_4 next_41_arg_1 = var_40;
    SORT_1 var_48_arg_0 = input_3;
    SORT_1 var_48 = ~var_48_arg_0;
    var_48 = var_48 & mask_SORT_1;
    SORT_4 var_49_arg_0 = state_6;
    SORT_4 var_49_arg_1 = state_9;
    SORT_1 var_49 = var_49_arg_0 > var_49_arg_1;
    SORT_1 var_50_arg_0 = var_48;
    SORT_1 var_50_arg_1 = var_49;
    SORT_1 var_50 = var_50_arg_0 & var_50_arg_1;
    var_50 = var_50 & mask_SORT_1;
    SORT_4 var_43_arg_0 = state_6;
    SORT_4 var_43_arg_1 = state_9;
    SORT_1 var_43 = var_43_arg_0 > var_43_arg_1;
    SORT_1 var_44_arg_0 = var_43;
    SORT_1 var_44 = ~var_44_arg_0;
    var_44 = var_44 & mask_SORT_1;
    SORT_4 var_45_arg_0 = state_6;
    SORT_4 var_45_arg_1 = var_22;
    SORT_1 var_45 = var_45_arg_0 != var_45_arg_1;
    SORT_1 var_46_arg_0 = var_44;
    SORT_1 var_46_arg_1 = var_45;
    SORT_1 var_46 = var_46_arg_0 | var_46_arg_1;
    var_46 = var_46 & mask_SORT_1;
    SORT_4 var_42_arg_0 = state_9;
    SORT_4 var_42_arg_1 = var_5;
    SORT_4 var_42 = var_42_arg_0 + var_42_arg_1;
    var_42 = var_42 & mask_SORT_4;
    SORT_1 var_47_arg_0 = var_46;
    SORT_4 var_47_arg_1 = var_42;
    SORT_4 var_47_arg_2 = state_6;
    SORT_4 var_47 = var_47_arg_0 ? var_47_arg_1 : var_47_arg_2;
    SORT_1 var_51_arg_0 = var_50;
    SORT_4 var_51_arg_1 = state_9;
    SORT_4 var_51_arg_2 = var_47;
    SORT_4 var_51 = var_51_arg_0 ? var_51_arg_1 : var_51_arg_2;
    SORT_4 next_52_arg_1 = var_51;
    // Assigning next states ...
    state_6 = next_41_arg_1;
    state_9 = next_52_arg_1;
  }
  return 0;
}
